commit 695dcff8e2c4dc110e8dfc9112f821fcbf0f5f1f
Author: Carles Marti <carles.marti-aliod@ens-lyon.fr>
Date:   Fri Jun 26 09:19:42 2020 +0200

    Added punctuation marks at the end of every log messages.

diff --git a/modules/dos_input.py b/modules/dos_input.py
index 856b2be..7ca22c4 100644
--- a/modules/dos_input.py
+++ b/modules/dos_input.py
@@ -205,7 +205,7 @@ def get_batch_q_sys():
 def get_subm_script():
     subm_script = dos_inp.get('Global', 'subm_script', fallback=False)
     if subm_script and not os.path.isfile(subm_script):
-        logger.error(f'File {subm_script} not found')
+        logger.error(f'File {subm_script} not found.')
         raise FileNotFoundError(f'File {subm_script} not found')
     return subm_script
 
@@ -283,7 +283,7 @@ def get_special_atoms():
 def get_isol_inp_file():
     isol_inp_file = dos_inp.get('Isolated', 'isol_inp_file')
     if not os.path.isfile(isol_inp_file):
-        logger.error(f'File {isol_inp_file} not found')
+        logger.error(f'File {isol_inp_file} not found.')
         raise FileNotFoundError(f'File {isol_inp_file} not found')
     return isol_inp_file
 
@@ -291,7 +291,7 @@ def get_isol_inp_file():
 def get_molec_file():
     molec_file = dos_inp.get('Isolated', 'molec_file')
     if not os.path.isfile(molec_file):
-        logger.error(f'File {molec_file} not found')
+        logger.error(f'File {molec_file} not found.')
         raise FileNotFoundError(f'File {molec_file} not found')
     return molec_file
 
@@ -339,7 +339,7 @@ def get_min_confs():
 def get_screen_inp_file():
     screen_inp_file = dos_inp.get('Screening', 'screen_inp_file')
     if not os.path.isfile(screen_inp_file):
-        logger.error(f'File {screen_inp_file} not found')
+        logger.error(f'File {screen_inp_file} not found.')
         raise FileNotFoundError(f'File {screen_inp_file} not found')
     return screen_inp_file
 
@@ -347,7 +347,7 @@ def get_screen_inp_file():
 def get_surf_file():
     surf_file = dos_inp.get('Screening', 'surf_file')
     if not os.path.isfile(surf_file):
-        logger.error(f'File {surf_file} not found')
+        logger.error(f'File {surf_file} not found.')
         raise FileNotFoundError(f'File {surf_file} not found')
     return surf_file
 
@@ -549,7 +549,7 @@ def get_try_disso():
 def get_refine_inp_file():  # TODO if not specified try isol_inp_file.
     refine_inp_file = dos_inp.get('Refinement', 'refine_inp_file')
     if not os.path.isfile(refine_inp_file):
-        logger.error(f'File {refine_inp_file} not found')
+        logger.error(f'File {refine_inp_file} not found.')
         raise FileNotFoundError(f'File {refine_inp_file} not found')
 
     return refine_inp_file
@@ -572,12 +572,12 @@ def read_input(in_file):
         dos_inp.read(in_file)
     except MissingSectionHeaderError as e:
         logger.error('There are options in the input file without a Section '
-                     'header')
+                     'header.')
         err = e
     except DuplicateOptionError as e:
         logger.error('There is an option in the input file that has been '
                      'specified more than once, possibly due to the lack of a '
-                     'Section header')
+                     'Section header.')
         err = e
     except Exception as e:
         err = e
@@ -685,7 +685,7 @@ def read_input(in_file):
         if return_vars['min_coll_height'] is not False and \
                 return_vars['surf_norm_vect'].tolist() not in cart_axes:
             logger.warning("'min_coll_height' option is only implemented for "
-                           "'surf_norm_vect' to be one of the x, y or z axes")
+                           "'surf_norm_vect' to be one of the x, y or z axes.")
 
     # Refinement
     if refinement:
@@ -708,7 +708,7 @@ def read_input(in_file):
     return_vars_str = "\n\t".join([str(key) + ": " + str(value)
                                    for key, value in return_vars.items()])
     logger.info(
-        f'Correctly read {in_file} parameters: \n\n\t{return_vars_str}\n')
+        f'Correctly read {in_file} parameters: \n\n\t{return_vars_str}\n.')
 
     return return_vars
 