Index: plugin.xml
===================================================================
--- plugin.xml	(revision 697)
+++ plugin.xml	(revision 698)
@@ -324,7 +324,7 @@
                id="menu.file"
                label="%menu.label">
             <separator
-                  name="org.txm.rcp.separator2"
+                  name="menu.file.separator.import"
                   visible="true">
             </separator>
             <menu
@@ -578,7 +578,7 @@
                </command>
             </menu>
             <separator
-                  name="fileSeparator1"
+                  name="menu.file.separator.file"
                   visible="true">
             </separator>
             <command
@@ -623,7 +623,7 @@
                   label="%command.label.93">
             </command>
             <separator
-                  name="org.txm.rcp.separator2"
+                  name="menu.file.separator.open"
                   visible="true">
             </separator>
             <command
@@ -633,7 +633,7 @@
                   tooltip="%command.tooltip">
             </command>
             <separator
-                  name="fileSeparator2"
+                  name="menu.file.separator.lang"
                   visible="true">
             </separator>
             <command
@@ -643,7 +643,7 @@
                   tooltip="%command.tooltip.42">
             </command>
             <separator
-                  name="org.txm.rcp.separator3"
+                  name="menu.file.separator.update"
                   visible="true">
             </separator>
             <command
@@ -684,7 +684,7 @@
                </visibleWhen>
             </command>
             <separator
-                  name="org.txm.rcp.separator1"
+                  name="menu.file.separator.close"
                   visible="true">
             </separator>
             <command
@@ -920,6 +920,14 @@
                id="menu.corpus"
                label="%menu.label.1"
                sibling_order="&lt;command&#x0A;                  commandId=&quot;org.txm.rcp.commands.function.ComputeConcordance&quot;&#x0A;                  icon=&quot;icons/functions/Concordances.png&quot;&#x0A;                  label=&quot;%command.label.11&quot;&#x0A;                  style=&quot;push&quot;&#x0A;                  tooltip=&quot;%command.tooltip.7&quot;&gt;&#x0A;               &lt;visibleWhen&#x0A;                     checkEnabled=&quot;false&quot;&gt;&#x0A;                  &lt;reference&#x0A;                        definitionId=&quot;OneCorpusSelected&quot;&gt;&#x0A;                  &lt;/reference&gt;&#x0A;               &lt;/visibleWhen&gt;&#x0A;            &lt;/command&gt;">
+            <separator
+                  name="menu.corpus.read"
+                  visible="true">
+            </separator>
+            <separator
+                  name="menu.corpus.manage"
+                  visible="true">
+            </separator>
             
             <command
                   commandId="org.txm.rcp.commands.base.DeleteObject"
@@ -984,15 +992,23 @@
          <menu
                id="menu.tools"
                label="%menu.label.6">
+            <separator
+                  name="menu.tools.separator.doc"
+                  visible="true">
+            </separator>
             
             <separator
-                  name="menu.tools.stats"
+                  name="menu.tools.separator.stats"
                   visible="true">
             </separator>
             <separator
-                  name="menu.tools.misc"
+                  name="menu.tools.separator.misc"
                   visible="true">
             </separator>
+            <separator
+                  name="menu.tools.separator.end"
+                  visible="true">
+            </separator>
             <command
                   commandId="org.eclipse.ui.window.preferences"
                   icon="icons/functions/prefs.png"
@@ -1897,14 +1913,13 @@
       <menuContribution
             locationURI="popup:org.txm.rcp.views.corpora.CorporaView">
          <separator
-               id="org.txm.rcp.corporaview.begin"
                name="org.txm.rcp.corporaview.begin"
                visible="true"/>
-               <separator
-               id="org.txm.rcp.corporaview.export"
-               name="org.txm.rcp.corporaview.export"
-               visible="true"/>
-            <command
+               <menu
+                     icon="icons/functions/export.png"
+                     id="org.txm.rcp.corporaview.export"
+                     label="Exporter">
+                     <command
                   commandId="org.txm.rcp.commands.function.ExportResult"
                   icon="icons/functions/export_data.png"
                   label="%command.label.51"
@@ -1972,11 +1987,20 @@
                   </or>
                </visibleWhen>
             </command>
+               </menu>
+            
             <separator
                   name="org.txm.rcp.corporaview.corpus"
-                  id="org.txm.rcp.corporaview.corpus"
                   visible="true">
             </separator>
+            <separator
+                  name="org.txm.rcp.corporaview.corpus.read"
+                  visible="true">
+            </separator>
+            <separator
+                  name="org.txm.rcp.corporaview.corpus.manage"
+                  visible="true">
+            </separator>
             
             <command
                   commandId="org.txm.rcp.commands.base.DeleteObject"
@@ -2014,31 +2038,39 @@
             </command>
             <separator
                   name="org.txm.rcp.corporaview.annotation"
-                  id="org.txm.rcp.corporaview.annotation"
                   visible="true">
             </separator>
             <separator
                   name="org.txm.rcp.corporaview.tools"
-                  id="org.txm.rcp.corporaview.tools"
                   visible="true">
             </separator>
-            <command
-                  commandId="org.eclipse.ui.window.preferences"
-                  icon="icons/functions/prefs.png"
-                  label="%command.label.4"
-                  style="push"
-                  tooltip="%command.tooltip.0">
-            </command>
+            <separator
+                  name="org.txm.rcp.corporaview.tools.doc"
+                  visible="true">
+            </separator>
+            <separator
+                  name="org.txm.rcp.corporaview.tools.stat"
+                  visible="true">
+            </separator>
+            <separator
+                  name="org.txm.rcp.corporaview.tools.misc"
+                  visible="true">
+            </separator>
          <separator
                name="org.txm.rcp.corporaview.text"
-               id="org.txm.rcp.corporaview.text"
                visible="true">
          </separator>
          <separator
                name="org.txm.rcp.corporaview.file"
-               id="org.txm.rcp.corporaview.file"
                visible="true">
          </separator>
+            <command
+                  commandId="org.eclipse.ui.window.preferences"
+                  icon="icons/functions/prefs.png"
+                  label="%command.label.4"
+                  style="push"
+                  tooltip="%command.tooltip.0">
+            </command>
 
       </menuContribution>
       <menuContribution